<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>AdminLTE 3 | Dashboard</title>

  <style>
      /* CSS for the analog meter */
      .meter {
          width: 200px;
          height: 200px;
          position: relative;
          border-radius: 50%;
          border: 2px solid black;
          margin: 20px auto;
      }
      .needle {
          position: absolute;
          width: 2px;
          height: 75px;
          top: 25%;
          left: 50%;
          transform-origin: bottom;
          transform: translateX(-50%) rotate(0deg);
          transition: transform 0.5s ease-in-out;
      }

      .modal {
            display: none;
            position: fixed;
            z-index: 1;
            left: 0;
            top: 0;
            width: 100%;
            height: 100%;
            overflow: auto;
            background-color: rgb(0,0,0);
            background-color: rgba(0,0,0,0.4);
            padding-top: 60px;
        }

        .modal-content {
            background-color: #fefefe;
            margin: 5% auto;
            padding: 20px;
            border: 1px solid #888;
            width: 80%;
        }

        .close {
            color: #aaa;
            float: right;
            font-size: 28px;
            font-weight: bold;
        }

        .close:hover,
        
        .close:focus {
            color: black;
            text-decoration: none;
            cursor: pointer;
        }



  </style>
  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Ionicons -->
  <link rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
  <!-- Tempusdominus Bootstrap 4 -->
  <link rel="stylesheet" href="plugins/tempusdominus-bootstrap-4/css/tempusdominus-bootstrap-4.min.css">
  <!-- iCheck -->
  <link rel="stylesheet" href="plugins/icheck-bootstrap/icheck-bootstrap.min.css">
  <!-- JQVMap -->
  <link rel="stylesheet" href="plugins/jqvmap/jqvmap.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <!-- overlayScrollbars -->
  <link rel="stylesheet" href="plugins/overlayScrollbars/css/OverlayScrollbars.min.css">
  <!-- Daterange picker -->
  <link rel="stylesheet" href="plugins/daterangepicker/daterangepicker.css">
  <!-- summernote -->
  <link rel="stylesheet" href="plugins/summernote/summernote-bs4.min.css">
</head>
<body class="hold-transition sidebar-mini layout-fixed">
<div class="wrapper">

  <!-- Preloader -->
  <div class="preloader flex-column justify-content-center align-items-center">
    <img class="animation__shake" src="dist/img/AdminLTELogo.png" alt="AdminLTELogo" height="60" width="60">
  </div>

  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      
      <li class="nav-item">
        <a style="margin-right: 50px;" class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
    

      <li class="nav-item d-none d-sm-inline-block">
        <div style="margin-right: 50px;" class="btn btn-success"><p id="datos_recividos">Datos Recibidos: </p></div>   <!-- Data recibida -->
      </li>

      <li class="nav-item d-none d-sm-inline-block">
        <div style="margin-right: 50px;" class="btn btn-info"><p id="datos_pi4">Estado: Sin Conexion</p></div>
      </li>

      <li class="nav-item d-none d-sm-inline-block">
        <div class="btn btn-secondary"><p id="ip">IP: 0.0.0.0</p></div>
      </li>
   
    </ul>

    <!-- Right navbar links -->
    <ul class="navbar-nav ml-auto">
     
      <li class="nav-item">
        <a class="nav-link" data-widget="fullscreen" href="#" role="button">
          <i class="fas fa-expand-arrows-alt"></i>
        </a>
      </li>
      <li class="nav-item">
        <a class="nav-link" data-widget="control-sidebar" data-controlsidebar-slide="true" href="#" role="button">
          <i class="fas fa-th-large"></i>
        </a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="#" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Dashboard PI-4</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user panel (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          
        </div>
        <div class="info">
          <a href="#" class="d-block">Alexander Pierce</a>
          <p></p>
          <a href="/" class="btn btn-outline-success">Salir de sesión</a>
        </div>
        

      </div>


      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="#" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard Principal</p>
                </a>
              </li>
            </ul>
          </li>
  
          <li class="nav-item">
            <a href="#" class="nav-link">
              <i class="nav-icon fas fa-chart-pie"></i>
              <p>
                Graficos
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a onclick="openForm(1)" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Añadir Grafica</p>
                </a>
              </li>
              <li class="nav-item">
                <a onclick="openForm(2)" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p >Añadir Medidor</p>
                  <p style="text-align: center;">Analogico</p>
                </a>
              </li>
              <li class="nav-item">
                <a onclick="openForm(3)" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Añadir Tacometro</p>
                </a>
              </li>
              <li class="nav-item">
                <a onclick="openForm(4)" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Añadir Medidor de Texto</p>
                </a>
              </li>
              <li class="nav-item">
                <a onclick="openForm_d(5)" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Añadir Sensor Digital</p>
                </a>
              </li>
              <li class="nav-item">
                <a onclick="addGraph_doble()" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Añadir Grafico Doble</p>
                </a>
              </li>
              
            </ul>
          </li>
        
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">Dashboard</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              
              
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content SECCION PRINCIPAL--> 
    <section class="content">
      

       <!-- FORM DE SENSORES -->

      <div id="myModal" class="modal">
        <!-- Modal content -->
        <div class="modal-content">
            <span class="close" onclick="closeForm_aux()">&times;</span> 
                    
                  <div class="row">  
                    
                    <div class="column" style="padding: 20px;">
                      <div class="row">
                      <label for="sensores">Escoja un sensor:</label>
                      <select id="sensores" class="form-control">  
                      <option value="sensor1">ANALOGICO 1</option>
                      <option value="sensor2">ANALOGICO 2</option>
                      <option value="sensor3">ANALOGICO 3</option>
                      <option value="sensor4">ANALOGICO 4</option>
                      <option value="sensor5">ANALOGICO 5</option>
                      <option value="sensor6">ANALOGICO 6</option>
                      <option value="sensor7">ANALOGICO 7</option>
                      <option value="sensor8">ANALOGICO 8</option>
                      </select>
                      </div>

                      <div class="row">
                      <label for="conversion">Ingrese un Factor de Conversion:</label>
                      <input type="text" class="form-control" id="conversion">
                      </div>

                    </div>

                    <div class="column" style="padding: 10px;">
                      <p>Escoja un color:</p>
                      <div class="row">
                      <input type="color" id="color_select" value="#49B84F" style="width: 125px; height:115px;">
                      </div>
                    </div>

                    <div class="column" style="padding: 20px;">
                      <label for="medida">Medida a Usar:</label>
                      <input type="text" class="form-control" id="medida">
                      <label for="medida">Nombre del Sensor:</label>
                      <input type="text" class="form-control" id="label_sensor">
                    </div>

                  </div>

                  <br>
                  <input type="button" class="btn btn-outline-success" value="Añadir" id="form_añadir" onclick="closeForm()">
        </div>
  </div> 


  <div id="myModal_d" class="modal">
    <!-- Modal content -->
    <div class="modal-content">
        <span class="close" onclick="closeForm_aux()">&times;</span> 
                
              <div class="row">  
                
                <div class="column" style="padding: 20px;">
                  <div class="row">
                  <label for="sensores_d">Escoja un sensor:</label>
                  <select id="sensores_d" class="form-control">  
                  <option value="sensor1">DIGITAL 1</option>
                  <option value="sensor2">DIGITAL 2</option>
                  <option value="sensor3">DIGITAL 3</option>
                  <option value="sensor4">DIGITAL 4</option>
                  <option value="sensor5">DIGITAL 5</option>
                  <option value="sensor6">DIGITAL 6</option>
                  <option value="sensor7">DIGITAL 7</option>
                  <option value="sensor8">DIGITAL 8</option>
                  </select>
                  </div>

                </div>

                <div class="column" style="padding: 20px;">
                  <label for="medida">Nombre del Sensor:</label>
                  <input type="text" class="form-control" id="label_sensor_d">
                </div>

              </div>

              <br>
              <input type="button" class="btn btn-outline-success" value="Añadir" id="form_añadir" onclick="closeForm()">
    </div>
</div> 


        <div  id="graphContainer"></div>
        
        <div  id="analogContainer"></div>
        
        <div class="row">
          <div class="col"></div>
          <div class="col" id="tacometer"></div>
          <div class="col"></div>
        </div>
        
        <div class="row">
          <div class="col"></div>
          <div  id="textAreaContainer"></div>
          <div class="col"></div>
        </div>
        
      


    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  <footer class="main-footer">
   
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- jQuery UI 1.11.4 -->
<script src="plugins/jquery-ui/jquery-ui.min.js"></script>
<!-- Resolve conflict in jQuery UI tooltip with Bootstrap tooltip -->
<script>
  $.widget.bridge('uibutton', $.ui.button)
</script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- ChartJS -->
<script src="plugins/chart.js/Chart.min.js"></script>
<!-- Sparkline -->
<script src="plugins/sparklines/sparkline.js"></script>
<!-- JQVMap -->
<script src="plugins/jqvmap/jquery.vmap.min.js"></script>
<script src="plugins/jqvmap/maps/jquery.vmap.usa.js"></script>
<!-- jQuery Knob Chart -->
<script src="plugins/jquery-knob/jquery.knob.min.js"></script>
<!-- daterangepicker -->
<script src="plugins/moment/moment.min.js"></script>
<script src="plugins/daterangepicker/daterangepicker.js"></script>
<!-- Tempusdominus Bootstrap 4 -->
<script src="plugins/tempusdominus-bootstrap-4/js/tempusdominus-bootstrap-4.min.js"></script>
<!-- Summernote -->
<script src="plugins/summernote/summernote-bs4.min.js"></script>
<!-- overlayScrollbars -->
<script src="plugins/overlayScrollbars/js/jquery.overlayScrollbars.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.js"></script>
<!-- AdminLTE for demo purposes -->
<script src="dist/js/demo.js"></script>
<!-- AdminLTE dashboard demo (This is only for demo purposes) -->
<script src="dist/js/pages/dashboard.js"></script>

<script src="https://cdn.jsdelivr.net/npm/chart.js"></script>



<script>


  $(document).ready(function() {  //  datos rasspery
    $("#ip").text("IP: "+api);  
    setInterval(function() {
          $.get(api+"info", function(data) {
            
              $("#datos_recividos").text("Datos Recibidos: " + data.info+" bytes");
              
              if (data.info>0){
                $("#datos_pi4").text("Estado: " + "Funcionando"); 
              }
              else{
                $("#datos_pi4").text("Estado: " + "Sin Conexion"); 
              }

          });
      }, 3000); // 3000 milisegundos = 3 segundos
  });
  

  
  // Script Obtener RGB
  function hexToRgb(hex) {
            var r = parseInt(hex.slice(1, 3), 16);
            var g = parseInt(hex.slice(3, 5), 16);
            var b = parseInt(hex.slice(5, 7), 16);
            return 'rgb(' + r + ', ' + g + ', ' + b + ')';
  }
  
  // SCRIPT POP UP
  var tipo;

  function openForm(dato) {
    document.getElementById("myModal").style.display = "block";
    tipo= dato;
  }

  function openForm_d(dato) {
    document.getElementById("myModal_d").style.display = "block";
    tipo= dato;
  }

  function closeForm() {
    document.getElementById("myModal").style.display = "none";
    document.getElementById("myModal_d").style.display = "none";

    var valor= document.getElementById('sensores').value;
    var valor_d=document.getElementById('sensores_d').value;
    var nombre_sensor= document.getElementById('label_sensor').value;
    var nombre_sensor_d=document.getElementById('label_sensor_d').value;
    var color= document.getElementById('color_select').value;
    var medida= document.getElementById('medida').value;
    var conversion= document.getElementById('conversion').value;

    color_selector=hexToRgb(color);
    if (tipo==1){
      addGraph(valor,nombre_sensor,color_selector,medida,conversion);
    }  
    if(tipo==2){
      addGraphAnalog(valor,nombre_sensor,color_selector,medida,conversion);
    }
    if(tipo==3){
      addTacometer(valor,nombre_sensor,color_selector,medida,conversion);
    }
    if(tipo==4){
      addTextArea(valor,nombre_sensor,color_selector,medida,conversion)
    }
    if(tipo==5){
      addGraph(valor_d,nombre_sensor_d,hexToRgb("#0000ff"),"MEDIDOR LOGICO",1);
    }
  }


  function closeForm_aux() {
    document.getElementById("myModal").style.display = "none";
    document.getElementById("myModal_d").style.display = "none";
  }



  // SCRIPT POP UP

  // SCRIPT GRAFICO DOBLE 

  function addGraph_doble() {
      // Create a canvas element for the graph
      var canvas = document.createElement('canvas');
      var canvas_sub = document.createElement('canvas');
      var graphContainer = document.getElementById('graphContainer');
      var blanco=document.createElement('p');
      var quitar=document.createElement('button');
      quitar.type="button"
      quitar.innerHTML="X"
      quitar.className="btn btn-danger"
      quitar.style="width: 5%; height:5%; right: 0px;"
      
      var canvasId ='canvas_g' + (graphContainer.querySelectorAll('canvas').length +1+Math.random());
      var canvasId_sub ='canvas_g' + (graphContainer.querySelectorAll('canvas').length +2+Math.random());
      
      canvas.id = canvasId;

      canvas_sub.id=canvasId_sub;

      blanco.id = 'blanco_' + canvasId;
      quitar.id = 'quitar_' + canvasId;

      graphContainer.appendChild(blanco);
      graphContainer.appendChild(quitar);
      graphContainer.appendChild(canvas);
      graphContainer.appendChild(canvas_sub);
      graphContainer.appendChild(blanco);
      // Initialize Chart.js chart
      var ctx = canvas.getContext('2d');
      var chart = new Chart(ctx, {
          type: 'line', // Change this to the desired chart type (line, bar, pie, etc.)
          data: {
              labels: [],
              datasets: [{
                  label: "Humedad",
                  data: [], // Sample data
                  borderColor: 'rgba(255, 99, 132, 1)',
                  borderWidth: 1
              }]
          },
          options: {
            scales: {
            y: {
                beginAtZero: true, // Ensures the y-axis starts at 0
                title: {
                    display: true,
                    text: "Sensor Dual" // Label for the y-axis
                }
            }
            }
          }
      });


      var ctx_sub = canvas_sub.getContext('2d');
      var chart_sub = new Chart(ctx_sub, {
          type: 'line', // Change this to the desired chart type (line, bar, pie, etc.)
          data: {
              labels: [],
              datasets: [{
                  label: "Temperatura",
                  data: [], // Sample data
                  borderColor: 'rgba(54, 162, 235, 1)',
                  borderWidth: 1
              }]
          },
          options: {
            scales: {
            y: {
                beginAtZero: true, // Ensures the y-axis starts at 0
                title: {
                    display: true,
                    text: "Sensor Dual" // Label for the y-axis
                }
            }
            }
          }
      });

      quitar.addEventListener('click', function() { //remover
        var elementToRemove_sub = document.getElementById(canvasId_sub);
        var elementToRemove = document.getElementById(canvasId);
        var buttonToRemove = document.getElementById('quitar_' + canvasId);
        var spacerToRemove = document.getElementById('blanco_' + canvasId);
        graphContainer.removeChild(elementToRemove);
        graphContainer.removeChild(elementToRemove_sub);
        graphContainer.removeChild(buttonToRemove);
        graphContainer.removeChild(spacerToRemove);

      });

      // Fetch JSON data and update chart every 3 seconds
      
      setInterval(function() {

        fetch(api+"sensor9") // url sensor
          .then(response => response.json())
          .then(data => {
            // Update labels and data arrays in the chart
            chart.data.labels.push(new Date().toLocaleTimeString());
            chart.data.datasets[0].data.push(data["sensor9"]);
            // Limit the number of data points shown to prevent cluttering
            if (chart.data.labels.length > 10) {
              chart.data.labels.shift();
              chart.data.datasets[0].data.shift();
            }
            // Update the chart
            chart.update();
         
          })
          .catch(error => console.error('Error fetching data:', error));
      }, 3000);

      
      setInterval(function() {

      fetch(api+"sensor10") // url sensor
        .then(response => response.json())
        .then(data => {
          // Update labels and data arrays in the chart
          chart_sub.data.labels.push(new Date().toLocaleTimeString());
          chart_sub.data.datasets[0].data.push(data["sensor10"]);
          // Limit the number of data points shown to prevent cluttering
          if (chart_sub.data.labels.length > 10) {
            chart_sub.data.labels.shift();
            chart_sub.data.datasets[1].data.shift();
          }
          // Update the chart
          chart_sub.update();
      
        })
        .catch(error => console.error('Error fetching data:', error));
      }, 3000);
      
    }

  // SCRIPT AÑADIR GRAFICA

  function addGraph(sensor,nombre_sensor,color_selector,medida,conversion) {
      // Create a canvas element for the graph
      var canvas = document.createElement('canvas');
      var graphContainer = document.getElementById('graphContainer');
      var blanco=document.createElement('p');
      var quitar=document.createElement('button');
      quitar.type="button"
      quitar.innerHTML="X"
      quitar.className="btn btn-danger"
      quitar.style="width: 5%; height:5%; right: 0px;"
      
      var canvasId ='canvas_g' + (graphContainer.querySelectorAll('canvas').length +1+Math.random());
      canvas.id = canvasId;

      blanco.id = 'blanco_' + canvasId;
      quitar.id = 'quitar_' + canvasId;

      graphContainer.appendChild(blanco);
      graphContainer.appendChild(quitar);
      graphContainer.appendChild(canvas);
      graphContainer.appendChild(blanco);
      // Initialize Chart.js chart
      var ctx = canvas.getContext('2d');
      var chart = new Chart(ctx, {
          type: 'line', // Change this to the desired chart type (line, bar, pie, etc.)
          data: {
              labels: [],
              datasets: [{
                  label: nombre_sensor,
                  data: [], // Sample data
                  borderColor: color_selector,
                  borderWidth: 1
              }]
          },
          options: {
            scales: {
            y: {
                beginAtZero: true, // Ensures the y-axis starts at 0
                title: {
                    display: true,
                    text: medida // Label for the y-axis
                }
            }
            }
          }
      });

      quitar.addEventListener('click', function() { //remover
        var elementToRemove = document.getElementById(canvasId);
        var buttonToRemove = document.getElementById('quitar_' + canvasId);
        var spacerToRemove = document.getElementById('blanco_' + canvasId);
        graphContainer.removeChild(elementToRemove);
        graphContainer.removeChild(buttonToRemove);
        graphContainer.removeChild(spacerToRemove);


      });

      // Fetch JSON data and update chart every 3 seconds
      setInterval(function() {

        fetch(api+sensor) // url sensor
          .then(response => response.json())
          .then(data => {
            // Update labels and data arrays in the chart
            chart.data.labels.push(new Date().toLocaleTimeString());
            chart.data.datasets[0].data.push(data[sensor]*conversion);
            // Limit the number of data points shown to prevent cluttering
            if (chart.data.labels.length > 10) {
              chart.data.labels.shift();
              chart.data.datasets[0].data.shift();
            }
            // Update the chart
            chart.update();
         
          })
          .catch(error => console.error('Error fetching data:', error));
      }, 3000);

      
      //let info = {"sensor": sensor, "nombre_sensor": nombre_sensor,"color_selector":color_selector,"medida":medida};
      //grafica_1.datos.push(info)

      //localStorage.setItem('grafica_1', JSON.stringify(grafica_1));

    }


  // SCRIPT AÑADIR MEDIDOR ANALOGICO
  
  function addGraphAnalog(sensor,nombre_sensor,color_selector,medida,conversion) {
      var contenedor = document.getElementById('analogContainer');
      var blanco=document.createElement('p');
      var devision_analogico = document.createElement('div');
      devision_analogico.className = 'meter';
      var aguja_analogico = document.createElement('div');
      aguja_analogico.className = 'needle';
      var needleId = 'needle' + (contenedor.querySelectorAll('.meter').length + 1+Math.random());
      aguja_analogico.id= needleId;
      aguja_analogico.style.backgroundColor=color_selector;
      devision_analogico.appendChild(aguja_analogico);
      var texto=document.createElement('p');
      texto.style="text-align: center;"
      texto.textContent=nombre_sensor+" [Medida: "+medida+"]";  

      var quitar=document.createElement('button');
      quitar.type="button"
      quitar.innerHTML="X"
      quitar.className="btn btn-danger"
      quitar.style="width: 5%; height:5%; right: 0px;"

      blanco.id = 'blanco_' + needleId;
      quitar.id = 'quitar_' + needleId;
      texto.id =  'texto_' + needleId;
      devision_analogico.id= 'devision_analogico_' + needleId; 

      contenedor.appendChild(quitar);
      contenedor.appendChild(texto);
      contenedor.appendChild(blanco);
      contenedor.appendChild(devision_analogico);
      contenedor.appendChild(blanco);

      quitar.addEventListener('click', function() { //remover
        var elementToRemove = document.getElementById('devision_analogico_' + needleId);
        var buttonToRemove = document.getElementById('quitar_' + needleId);
        var spacerToRemove = document.getElementById('blanco_' + needleId);
        var texto_g = document.getElementById('texto_' + needleId);


        contenedor.removeChild(elementToRemove);
        contenedor.removeChild(buttonToRemove);
        contenedor.removeChild(spacerToRemove);
        contenedor.removeChild(texto_g);



      });

      setInterval(function() {
        fetch(api+sensor) // url sensor
          .then(response => response.json())
          .then(data => {
            updateMeter(data[sensor]*conversion,needleId)
          })
          .catch(error => console.error('Error fetching data:', error));
      }, 3000);


   
    } 
          
      function updateMeter(value,needleId) {
            var needle = document.getElementById(needleId);
            var angle = value * 1.8 - 90; // Convert input value to degree
            needle.style.transform = `translateX(-75%) rotate(${angle}deg)`;
      }

  ///////////////////////////////////////////

  /////////// añadir tacometro
      function addTacometer(sensor,nombre_sensor,color_selector,medida,conversion) {
            // Create a canvas element for the circular percentage
            var canvas = document.createElement('canvas');
            var tacometer = document.getElementById('tacometer');
            var blanco=document.createElement('p');
            var texto=document.createElement('p');
            texto.textContent=nombre_sensor+" [Medida: "+medida+"]";
            texto.style="text-align: center;"
            
            var canvasId='canvas_t' + (tacometer.querySelectorAll('canvas').length + 1+Math.random()); 
            canvas.id = canvasId

            var quitar=document.createElement('button');
            quitar.type="button"
            quitar.innerHTML="X"
            quitar.className="btn btn-danger"
            quitar.style="width: 10%; height:10%; right: 0px;"

            texto.id='texto_'+canvasId;
            blanco.id = 'blanco_' + canvasId;
            quitar.id = 'quitar_' + canvasId;

            tacometer.appendChild(quitar);
            tacometer.appendChild(texto);
            tacometer.appendChild(blanco);
            tacometer.appendChild(canvas);
            tacometer.appendChild(blanco);
            var ctx = canvas.getContext('2d');
            var chart = new Chart(ctx, {
                type: 'doughnut',
                data: {
                    datasets: [{
                        label: nombre_sensor,
                        data: [0,100],
                        backgroundColor: [color_selector, '#EEEEEE']
                    }]
                },
                options: {
                    cutoutPercentage: 80, // Adjust the size of the hole in the middle
                    responsive: false,
                    maintainAspectRatio: true,
                    legend: {
                        display: false
                    },
                    animation: {
                        animateScale: true,
                        animateRotate: true
                    }
                }
            });


            quitar.addEventListener('click', function() { //remover
              var elementToRemove = document.getElementById(canvasId);
              var buttonToRemove = document.getElementById('quitar_' + canvasId);
              var spacerToRemove = document.getElementById('blanco_' + canvasId);
              var texto_g = document.getElementById('texto_' + canvasId);

              tacometer.removeChild(elementToRemove);
              tacometer.removeChild(buttonToRemove);
              tacometer.removeChild(spacerToRemove);
              tacometer.removeChild(texto_g);

            });


            setInterval(function () {
            fetch(api+sensor) // url sensor
                  .then(response => response.json())
                  .then(data => {
                      // Update labels and data arrays in the chart
                      chart.data.datasets[0].data = [data[sensor]*conversion, 100 - data[sensor]*conversion];
                      chart.update();
                  })
                  .catch(error => console.error('Error fetching data:', error));
                  }, 3000);
  
      

    
    }

  /////////////////////////////////////            

  // Medidor de texto
  
  function addTextArea(sensor,nombre_sensor,color_selector,medida,conversion) {
  // Create a textarea element for displaying text
  var textArea = document.createElement('input');
  var blanco=document.createElement('p');
  var textAreaContainer = document.getElementById('textAreaContainer');
  var texotid='textarea_' +  (textAreaContainer.querySelectorAll('input').length + 1+Math.random());
  textArea.id = texotid
  textArea.type="text"
  textArea.readOnly="readonly"
  textArea.size="70"
  textArea.style="text-align: center;"
  blanco.id='blanco_'+texotid;

  var quitar=document.createElement('button');
  quitar.type="button"
  quitar.innerHTML="X"
  quitar.className="btn btn-danger"
  quitar.style="width: 10%; height:40%; right: 0px;"
  quitar.id='quitar_'+texotid;

  textAreaContainer.appendChild(quitar); 
  textAreaContainer.appendChild(blanco); 
  textAreaContainer.appendChild(textArea);
  textAreaContainer.appendChild(blanco);
  
  quitar.addEventListener('click', function() { //remover
              var elementToRemove = document.getElementById(texotid);
              var buttonToRemove = document.getElementById('quitar_' + texotid);
              var spacerToRemove = document.getElementById('blanco_' + texotid);
              
              textAreaContainer.removeChild(elementToRemove);
              textAreaContainer.removeChild(buttonToRemove);
              textAreaContainer.removeChild(spacerToRemove);
              

            });




  // Fetch JSON data and update textarea every 3 seconds
  setInterval(function() {
    fetch(api+sensor) // URL del sensor
      .then(response => response.json())
      .then(data => {
        // Construct the text to display in the textarea
        var newText = nombre_sensor.toUpperCase()+' :' + '\n';
        newText += ' Hora: ' + new Date().toLocaleTimeString() + '\n';
        newText += ' Valor: ' + data[sensor]*conversion +" [Medida: "+medida+"]"+'\n\n';

        // Append new text to the existing content in the textarea
        textArea.value = newText;

        // Limit the number of lines shown to prevent cluttering
        var lines = textArea.value.split('\n');
        if (lines.length > 10) {
          // Remove the oldest line if the limit is reached
          textArea.value = lines.slice(1).join('\n');
        }
      })
      .catch(error => console.error('Error fetching data:', error));
  }, 3000);


}

///////////////////////

</script>



<script>

 
window.onload = function() {
    history.pushState(null, document.title, location.href);
    window.addEventListener('popstate', function (event) {
        history.pushState(null, document.title, location.href);
    });
};

/*
// Carga de datos
  
 
  window.onload = function() {
      
    if (JSON.parse(localStorage.getItem("grafica_1"))!=null){
      grafica_1 = JSON.parse(localStorage.getItem("grafica_1"))
    }
   
  };
  */
  
  
  </script>


</body>
</html>
